uniform mat4 u_modelview;
uniform mat4 u_projection;
varying lowp vec4 v_color;
varying mediump vec2 v_texcoord;

attribute highp vec3 a_Vertex;
attribute lowp vec4 a_Color;
attribute mediump vec2 a_MultiTexCoord0;
attribute mediump vec4 a_MatrixIndex;
attribute mediump vec4 a_Weight;

uniform highp mat4  u_matrix_palette[9];
uniform int u_bone_count;


uniform int u_has_texture0_matrix;
uniform mat4 u_texture0_matrix;

void main()
{
	highp mat4 mv = u_modelview;
	/*if(u_bone_count > 0)
	{
		mediump ivec4 indexOfBone = ivec4(a_MatrixIndex);
		mediump vec4 weightOfBone = a_Weight;
		mv = u_matrix_palette[indexOfBone.x] * weightOfBone.x;
	
		for (lowp int i = 1; i < 4; i++)
		{
			if(i < u_bone_count)
			{
				indexOfBone = indexOfBone.yzwx;
				weightOfBone = weightOfBone.yzwx;
				if (weightOfBone.x > 0.0)
				{
					mv = mv + u_matrix_palette[indexOfBone.x] * weightOfBone.x;
				}
			}
		}
	}*/

	gl_Position = u_projection * mv * vec4(a_Vertex, 1.0);
	
	if(u_has_texture0_matrix == 1)
	{
		mediump vec4 uv4 = u_texture0_matrix * vec4(a_MultiTexCoord0.xy, 0.0, 1.0);
		uv4 = uv4 / uv4.w;
		v_texcoord = uv4.xy;
	}
	else
	{
		v_texcoord = a_MultiTexCoord0;
	}
	v_color = a_Color;
}