uniform mat4 u_modelview;
uniform mat4 u_projection;
varying vec4 v_color;

uniform vec3 u_height_min_max;
uniform vec3 u_tex_offset_scale;
uniform vec4 u_color;

uniform float u_scaling;

uniform sampler2D texture0;

varying vec2 v_texcoord;

void main()
{
	vec2 uv = (gl_Vertex.xz) * u_tex_offset_scale.y + u_tex_offset_scale.xz;
	v_texcoord = uv;
	
	vec4 tex_color_middle = texture2D(texture0, v_texcoord);
	vec4 hm_pos = gl_Vertex;
	hm_pos.y = u_height_min_max.x + (u_height_min_max.y - u_height_min_max.x) * tex_color_middle.r;
	hm_pos.y = hm_pos.y / u_scaling;
	

	gl_Position = u_projection * u_modelview * hm_pos;
	v_color = u_color; 
}