attribute highp vec3 a_Vertex;
attribute lowp vec4 a_Color;
attribute mediump vec2 a_MultiTexCoord0;

uniform highp mat4 u_modelview;      // A constant representing the combined model/view/projection matrix.
uniform highp mat4 u_projection;       // A constant representing the combined model/view matrix.

uniform highp vec3 u_height_min_max;
 
varying highp vec3 v_Position;       // This will be passed into the fragment shader.
varying lowp vec4 v_Color;          // This will be passed into the fragment shader.

varying mediump vec2 v_texcoord;

uniform sampler2D texture3;
 
// The entry point for our vertex shader.
void main()
{
	v_texcoord = a_MultiTexCoord0.xy;			
	lowp vec4 tex_color_middle = texture2D(texture3, v_texcoord);

	lowp float hf = tex_color_middle.r;// * 1.01 ;
		
	highp vec4 hm_pos = vec4(a_Vertex, 1.0);
	hm_pos.y = u_height_min_max.x + (u_height_min_max.y - u_height_min_max.x) * hf ;
		
    // Transform the vertex into eye space.
    v_Position = vec3(u_modelview * hm_pos);
 
    // Pass through the color.
    v_Color = a_Color;
   
    // gl_Position is a special variable used to store the final position.
    // Multiply the vertex by the matrix to get the final point in normalized screen coordinates.
    
    gl_Position = u_projection * u_modelview * hm_pos;
}


